from System.Collections.Generic import List
from System import Byte, Int32
#
# Set this to the exact name of your pick script .. capital matters
# and it has to be in your list of scripts on UI
#
NameOfPickScript = "LockPick_chest_2.py"
#
# First keep track of position in book 
#
RuneBooks = [0x428B31BA, 0x428B31B3, 0x40CDA058 ]
RuneBookIndex = 0
RuneBookIndexName = "Lockpick RuneBook Order"
if Misc.CheckSharedValue(RuneBookIndexName):
    RuneBookIndex = Misc.ReadSharedValue(RuneBookIndexName)
#    
#
#
# Next keep track of position in book. At end of a book we'll set next book 
#
RuneOrder = [ 5, 11, 17, 23, 29, 35, 41, 47, 53, 59, 65, 71, 77, 83, 95 ] 
#
# First set which rune to use to 0 in case its not stored yet
# if its stored we'll use the stored value 
RuneIndex = 0
RuneIndexName = "Lockpick Rune Order"
if Misc.CheckSharedValue(RuneIndexName):
    RuneIndex = Misc.ReadSharedValue(RuneIndexName)
#    
# Now store whatever it is +1 so next time we'll do the next one
new_rune_index = RuneIndex+1
# check if the new index is past the end, then start back at 0
if new_rune_index >= len(RuneOrder):
    new_rune_index = 0
    # and move to the next book
    new_book_index = RuneBookIndex+1
    # check if the new book index is past the end, then start back at 0
    # Maybe want to stop here, because probably chests have not respawned
    if new_book_index >= len(RuneBooks):
        new_book_index = 0
    Misc.SetSharedValue(RuneBookIndexName, new_book_index) 

# Now store the next rune so that next time we come here we start with the new one
Misc.SetSharedValue(RuneIndexName, new_rune_index)
#
#
# A function I'll need later to check if runbook entry is Empty
#
def RuneBookFirstNameIndex():    
    gumpList = Gumps.LastGumpGetLineList()
    textParts = ["Charges:", "Max Charges:", "Rename book", "Drop rune", 
                 "Set default", "Recall", "Gate Travel", "Sacred Journey" ]
    index = 0
    #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
    while gumpList[index].strip() in textParts:
        #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
        index = index + 1
        # now index should be at the charges numbers so skip 1 more
    index = index + 2
    #Misc.SendMessage("Starts at: {}".format(index))
    return index
#
# Now finally everything is set. 
#
#
# RuneBookIndex is set to the current book to use
# RuneIndex is set to which rune in that book to use
Gumps.ResetGump()
Items.UseItem(RuneBooks[RuneBookIndex])
Gumps.WaitForGump(Gumps.CurrentGump(), 10000)
bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+RuneIndex)
Misc.SendMessage(bookSlotName.strip().lower()) 
if bookSlotName.strip().lower() != "empty":
    Gumps.SendAction(Gumps.CurrentGump(), RuneOrder[RuneIndex])
    Misc.Pause(15000)
    # now I guess we are close to a chest, lets move if we need to
    PickableChests = List[int]([ 0x0E40, 0x0E41, 0x09AB, 0x0E42, 0x0E43, 0x0E77, 0x0E7C, 0x0E7E, 0x09A9, 0x0E7F, 0x0E3E, 0x0E3D, 0x0E3F, 0x0E3C])
    chest = Items.Filter()
    chest.Enabled = True
    chest.OnGround = True
    chest.Movable = False
    chest.Graphics = PickableChests
    chest.RangeMax = 5
    chestOnGround = Items.ApplyFilter(chest)
    #
    if len(chestOnGround) > 0:
        nearestChest = Items.Select(chestOnGround, 'Nearest')
        Misc.SendMessage("Chest id 0x{:x} at X: {} Y: {}".format(nearestChest.Serial, nearestChest.Position.X, nearestChest.Position.Y), 5)
        Player.PathFindTo(nearestChest.Position.X, nearestChest.Position.Y, nearestChest.Position.Z)
        Misc.ScriptRun(NameOfPickScript)
        # wait on it to finish
        while Misc.ScriptStatus(NameOfPickScript):
            Misc.Pause(500)
    else:
        Misc.SendMessage("I don't see any chests within 5 squares", 5)
else:
    Misc.SendMessage("Skipping recall slot {} because it is empty".format(RuneIndex))

